﻿Ext.define('App.Control.DownloadField', {
    extend: 'Ext.button.Button',
    xtype: 'downloadField',
    config: {
        _parentContainer: null,
        iconCls: 'x-fa fa-download',
        text: '导出数据',
        urlBase: null, //是否从其它服务器加载
        dataSource: null, //数据源
        fileName: '数据导出',
        dynamicalFilter: {}, //自定义动态请求参数
        window: {
            type: null,
            title: '选择模板',
            iconCls: 'x-fa fa-file-excel-o',
            autoScroll: true,
            width: 700,
            height: 350,
            closeAction: 'hide',
            modal: true,
            layout: 'fit',
            filter: {

            }
        }
    },
    listeners: {
        added: '_onAdded', //当本控件被添加后，给_parentContainer赋值
        click: '_onDownload'
    },
    controller: {
        _onAdded: function(_ctrl, _parent) {
            _ctrl._parentContainer = _parent;
        },
        _onDownload: function(_ctrl) {
            let _windowConfig = _ctrl.getWindow();
            if (!_windowConfig.type) return;
            if (!_ctrl.dataSource) return;
            let _controller = this;
            let _vm = _controller.getViewModel();
            let _view = _controller.getView();
            let _dynamicalFilter = _ctrl.dynamicalFilter;
            let _grid = _view.up('grid');
            let _filter = null;
            let _globalFilter = null;
            let _searchFilter = null;
            let _sorts='';
            let _pageSize = 0;
            let _currentPage = 0;
            let _totalPage = 0;
            if (_grid !== null && _grid !== undefined) {
            	let _sorters=_grid.getStore().sorters.items;
            	for (i = 0; i < _sorters.length; i++) {
                    _sorts += (_sorters[i].getDirection().toLocaleLowerCase() == "asc" ? "" : "-") + _sorters[i].config.property + ',';
                }
                _filter = _grid.getFilter();
                _globalFilter = _grid.getGlobalFilter();
                _searchFilter = _grid.getSearchFilter();

                _pageSize = _grid.getStore().getPageSize();
                _currentPage = _grid.getStore().currentPage;
                _totalPage = Math.ceil(_grid.getStore().totalCount / _pageSize);
            }
            let _selector = Ext.create(_windowConfig.type);
            _windowConfig.items = [_selector];

            let _name = _ctrl.fileName;

            let _win = Ext.create('Ext.window.Window', _windowConfig);
            _win.show();
            _selector.setFilter(_windowConfig.filter);
            // _selector.setFilter({
            // 	FolderPath: '/Finances/Invoice/Files',
            //     Tags: 'Invoice'
            // });
            _selector.on('entitySelected', function(_selectorView, _entity) {
                _win.close();
                let _iframe = document.createElement("iframe");
                _iframe.style.display = "none";
                let _form = document.createElement('form');
                if (_globalFilter !== null) {
                    for (let _globalKey in _globalFilter) {
                        let _globalValue = document.createElement('input');
                        _globalValue.type = 'hidden';
                        _globalValue.name = _globalKey;
                        _globalValue.value = _globalFilter[_globalKey];
                        if (_globalFilter[_globalKey]&&(typeof _globalFilter[_globalKey] === 'object') && _globalFilter[_globalKey].constructor === Date) {
                            let _globalDate = _globalFilter[_globalKey].getFullYear() + '-' + (_globalFilter[_globalKey].getMonth() + 1) + '-' + _globalFilter[_globalKey].getDate();
                            _globalValue.value = _globalDate;
                        }
                        _form.appendChild(_globalValue);
                    }
                }
                if (_filter !== null) {
                    for (let _filterKey in _filter) {
                        let _filterValue = document.createElement('input');
                        _filterValue.type = 'hidden';
                        _filterValue.name = _filterKey;
                        _filterValue.value = _filter[_filterKey];
                        if (_filter[_filterKey]&&(typeof _filter[_filterKey] === 'object') && _filter[_filterKey].constructor === Date) {
                            let _filterDate = _filter[_filterKey].getFullYear() + '-' + (_filter[_filterKey].getMonth() + 1) + '-' + _filter[_filterKey].getDate();
                            _filterValue.value = _filterDate;
                        }
                        _form.appendChild(_filterValue);
                    }
                }
                if (_searchFilter !== null) {
                    for (let _searchKey in _searchFilter) {
                        let _searchValue = document.createElement('input');
                        _searchValue.type = 'hidden';
                        _searchValue.name = _searchKey;
                        _searchValue.value = _searchFilter[_searchKey];
                        if (_searchFilter[_searchKey]&&(typeof _searchFilter[_searchKey] === 'object') && _searchFilter[_searchKey].constructor === Date) {
                            let _searchDate = _searchFilter[_searchKey].getFullYear() + '-' + (_searchFilter[_searchKey].getMonth() + 1) + '-' + _searchFilter[_searchKey].getDate();
                            _searchValue.value = _searchDate;
                        }
                        _form.appendChild(_searchValue);
                    }
                }

                if (_dynamicalFilter !== null) {
                    for (let _dynamicalKey in _dynamicalFilter) {
                        let _dynamicalValue = document.createElement('input');
                        _dynamicalValue.type = 'hidden';
                        _dynamicalValue.name = _dynamicalKey;
                        _dynamicalValue.value = _dynamicalFilter[_dynamicalKey];
                        if (_dynamicalFilter[_dynamicalKey]&&(typeof _dynamicalFilter[_dynamicalKey] === 'object') && _dynamicalFilter[_dynamicalKey].constructor === Date) {
                            let _searchDate = _dynamicalFilter[_dynamicalKey].getFullYear() + '-' + (_dynamicalFilter[_dynamicalKey].getMonth() + 1) + '-' + _dynamicalFilter[_dynamicalKey].getDate();
                            _dynamicalValue.value = _searchDate;
                        }
                        _form.appendChild(_dynamicalValue);
                    }
                }

                let _view = document.createElement('input');
                _view.type = 'hidden';
                _view.name = 'View';
                _view.value = _entity[0].Path;
                _form.appendChild(_view);

                let _fileName = document.createElement('input');
                _fileName.type = 'hidden';
                _fileName.name = '__fileName';
                _fileName.value = _totalPage === 0 ? _name : _name + '(第' + _currentPage + '页,共' + _totalPage + '页)';
                _form.appendChild(_fileName);
                if (_totalPage !== 0) {

                    let _skip = document.createElement('input');
                    _skip.type = 'hidden';
                    _skip.name = 'Skip';
                    _skip.value = (_currentPage - 1) * _pageSize;
                    _form.appendChild(_skip);

                    let _take = document.createElement('input');
                    _take.type = 'hidden';
                    _take.name = 'Take';
                    _take.value = _pageSize;
                    _form.appendChild(_take);
                }
                if(_sorts!==''){
	                let _orderBy = document.createElement('input');
	                _orderBy.type = 'hidden';
	                _orderBy.name = 'OrderBy';
	                _orderBy.value = _sorts;
	                _form.appendChild(_orderBy);
                }

                _iframe.appendChild(_form);
                document.body.appendChild(_iframe);
                _form.method = 'GET';
                _form.action = _ctrl.dataSource;
                _form.submit();
                document.body.removeChild(_iframe);
            });
        }
    }
});