﻿Ext.define('App.Control.Kivii.Finances.InvoiceApply.Payment.Selector', {
    extend: 'System.Control.EntitySelector',
    entityType: 'Kivii.Finances.Entities.Payment',
    xtype: 'App.Control.Kivii.Finances.InvoiceApply.Payment.Selector',
    dataSource: '/Restful/Kivii.Finances.Entities.Payment/InvoiceApplyQuery.json',

    filter: {},
    store: {
        autoLoad: true
    },
    selModel: {
        selType: 'checkboxmodel',
        checkboxSelect: true,
        pruneRemoved: false,
        extensible: 'y'
    },
    tbar: [{
        margin: '0 3 -10 3',
        xtype: 'displayfield',
        value: '<div style="color:red">若未找到开票收款,请先到账管理中认领</div>',
        fieldStyle: {
            fontSize: '20px'
        }

    }, {
        xtype: 'searchField',
        flex: 1,
        labelWidth: 60,
        queryField: 'SerialNumber,PayerName,PayerAccountName,PayerAccountSerialNumber',
        emptyText: '模糊搜索流水号、付款单位、收付款账号或名称'
    }],
    columns: {
        defaults: {
            menuDisabled: true,
            sortable: true
        },
        items: [{
            xtype: 'rownumberer',
            align: 'center',
            resizable: false
        }, {
            text: '流水号',
            dataIndex: 'SerialNumber',
            width: 120
        }, {
            text: '付款单位',
            dataIndex: 'PayerName',
            width: 220
        }, {
            text: '发生金额',
            align: 'right',
            dataIndex: 'Amount',
            width: 110
        }, {
            text: '开票金额',
            align: 'right',
            dataIndex: 'AmountInvoice',
            width: 100
        }, {
            text: '付款类型',
            dataIndex: 'Type',
            renderer: '_renderType',
            width: 100
        }, {
            xtype: 'datecolumn',
            text: '发生日期',
            format: 'Y-m-d H:i',
            dataIndex: 'OperateTime',
            width: 150
        }, {
            text: '摘要',
            dataIndex: 'Summary',
            width: 150
        }, {
            text: '备注',
            dataIndex: 'Remark',
            minWidth: 150,
            flex: 1
        }]
    },
    controller: {
        _renderType: function(_value, _meta, _record, _rowIndex) {
            if (_value === 'Cash') {
                return '现金';
            }
            if (_value === 'Pos') {
                return '刷卡';
            }
            if (_value === 'AliPay') {
                return '支付宝';
            }
            if (_value === 'WeChat') {
                return '微信';
            }
            if (_value === 'Bank') {
                return '银行转账';
            }
            if (_value === 'Split') {
                return '已认领到账';
            }
            return _value;
        }
    }
});